;; $Id: dbtable.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

;; This is pretty weak.  There's no support for most attributes, etc.
;; yet.  Don't know when there will be, either... ;-/

(mode table-head-mode
  (element Row
    (make element gi: "TR"))
  (element Entry
    (make element gi: "TH")))

(mode table-foot-mode
  (element Row
    (make element gi: "TR"))
  (element Entry
    (make element gi: "TH")))

(mode table-body-mode
  (element Row
    (make element gi: "TR"))
  (element Entry
    (make element gi: "TD")))

(element INFORMALTABLE
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(process-children)))

(element TABLE
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(with-mode block-caption-mode
	  (process-first-descendant "TITLE"))
	(process-children)))

(element (TABLE TITLE) (empty-sosofo))

(element TGROUP
  (let* ((wrapper (parent (current-node)))
	 (frameattr (attribute-string "FRAME" wrapper))
	 (footnotes (select-elements (descendants (current-node)) "FOOTNOTE"))
	 (tblattr (if (equal? frameattr "NONE")
		      '(("BORDER" "0"))
		      '(("BORDER" "1")))))
    (make element gi: "TABLE"
	  attributes: tblattr
	  (process-children)
	  (if (node-list-empty? footnotes)
	      (empty-sosofo)
	      (make element gi: "TR"
		    attributes: '(("CLASS" "FOOTNOTES"))
		    (make element gi: "TD"
			  attributes: (list
				       (list "COLSPAN"
					     (attribute-string "COLS")))
			  (make sequence
			    (if (string=? %gentext-table-footnote-caption%
					  "")
				(empty-sosofo)
				(literal %gentext-table-footnote-caption%))
			    (with-mode footnote-mode
			      (process-node-list footnotes)))))))))

(element THEAD
  (with-mode table-head-mode
    (process-children)))

(element TBODY
  (with-mode table-body-mode
    (process-children)))

(element TFOOT
  (with-mode table-foot-mode
    (process-children)))

