;; $Id: dbverb.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

(define ($verbatim-display$)
  (let ((content (make element gi: "PRE"
		       attributes: (list
				    (list "CLASS" (gi)))
		       (process-children))))
    (if %shade-verbatim%
	(make element gi: "TABLE"
	      attributes: %shade-verbatim-attr%
	      (make element gi: "TR"
		    (make element gi: "TD"
			  content)))
	content)))

(define ($linespecific-display$)
  (make element gi: "PRE"
	(process-children)))

(element LITERALLAYOUT ($linespecific-display$))
(element ADDRESS ($linespecific-display$))
(element PROGRAMLISTING ($verbatim-display$))
(element SCREEN ($verbatim-display$))

;; screenshot is a graphic with possible screeninfo
;; *** TO DO: deal with this
(element SCREENSHOT (process-children))
(element SCREENINFO ($paragraph$))

